/*
 * COPYRIGHT LICENSE: This information contains sample code provided in source code form.
 * You may copy, modify, and distribute these sample programs in any form without payment
 * to IBM for the purposes of developing, using, marketing or distributing application
 * programs conforming to the application programming interface for the operating platform
 * for which the sample code is written.
 *
 * Notwithstanding anything to the contrary, IBM PROVIDES THE SAMPLE SOURCE CODE ON
 * AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING,
 * BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS OF MERCHANTABILITY,
 * SATISFACTORY QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND ANY WARRANTY OR
 * CONDITION OF NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR OPERATION OF
 * THE SAMPLE SOURCE CODE. IBM HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT,
 * UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE SAMPLE SOURCE CODE.
 *
 * (C) Copyright IBM Corp. 2013.
 * All Rights Reserved. Licensed Materials - Property of IBM.
 */
package com.ibm.websphere.sample.registration.ejb;

import java.util.Date;
import java.util.List;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.inject.Named;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import com.ibm.websphere.sample.registration.data.AuditEntry;

/**
 * Session Bean implementation class AuditBean
 */
@Stateless
@LocalBean
@Named
public class AuditBean  {

    
    @PersistenceContext(unitName = "RegistrationAppWeb")
    EntityManager emAudit;
	
	
    /**
     * Default constructor. 
     */
    public AuditBean() {}

	public void logUpdate(String update) {
		AuditEntry ae = new AuditEntry();
		ae.setDate(new Date());
		ae.setMessage(update);
		emAudit.persist(ae);
	}

	public List<AuditEntry> getLog() {
		String queryString = "SELECT a FROM AuditEntry a";
	    Query query = emAudit.createQuery(queryString);
	    
	    @SuppressWarnings("unchecked")
		List<AuditEntry> messages = query.getResultList();
	    
	    return messages;
	}

}
