/*
 * COPYRIGHT LICENSE: This information contains sample code provided in source code form.
 * You may copy, modify, and distribute these sample programs in any form without payment
 * to IBM for the purposes of developing, using, marketing or distributing application
 * programs conforming to the application programming interface for the operating platform
 * for which the sample code is written.
 *
 * Notwithstanding anything to the contrary, IBM PROVIDES THE SAMPLE SOURCE CODE ON
 * AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING,
 * BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS OF MERCHANTABILITY,
 * SATISFACTORY QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND ANY WARRANTY OR
 * CONDITION OF NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR OPERATION OF
 * THE SAMPLE SOURCE CODE. IBM HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT,
 * UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE SAMPLE SOURCE CODE.
 *
 * (C) Copyright IBM Corp. 2013.
 * All Rights Reserved. Licensed Materials - Property of IBM.
 */
define(["dojo/json", "dojo/dom-construct", "dojo/_base/array", "dojo/request", "dojo/dom", "dojo/parser", "dijit/registry", "dojo/on", "dijit/form/TextBox","dojo/domReady!"],
    function(json, domConstruct, arrayUtil, request, dom, parser, registry, on){

	var register ={};
	
	removeAttendee = function(unregisterButton) {
		request.post("rest/search/delete?email="+unregisterButton.id).then(
	      	function(response){
	      		var person = json.parse(response, true);
	      		var anchor = dom.byId("anchor"+person.email);
	      		var attendenceBox = dom.byId("checkbox"+person.email);
	      		if (anchor) {
	      			anchor.innerHTML = "(Removed) " + person.name + " ("+ person.email+ ") - " +  ((person.arrived) ? "Arrived" : "Not Arrived");
	      			domConstruct.destroy(unregisterButton);
	      			domConstruct.destroy(attendenceBox);
	      		} else {reportError("Error reported");}
	      	},
	      	function(err){reportError(err);});
	};
		 
	
	
	updateattendance = function(checkbox) {
		request.post("rest/search/update?email="+checkbox.id+"&state="+checkbox.checked).then(
	      	function(response){
	      		var person = json.parse(response, true);
	      		var anchor = dom.byId("anchor"+person.email);
	      		if (anchor) {
	      			anchor.innerHTML = "(Updated) " + person.name + " ("+ person.email+ ") - " +  ((person.arrived) ? "Arrived" : "Not Arrived");
	      		} else {reportError("Error reported");}
	      	},
	      	function(err){reportError(err);});
	};
		 
	processrequest = function(data) {
        var items = json.parse(data, true);
        var outputList = dom.byId("outputList"); 	
        domConstruct.empty(outputList);
        arrayUtil.forEach(items, function(person){
          var listItem = domConstruct.create("li", null , outputList);
          var checkbox = domConstruct.create("input", { id: "checkbox"+person.email, type:"checkbox"}, listItem);
          var unregisterButton = domConstruct.create("input", { class: "removeButton", id: "button"+person.email, value:"Remove Attendee", type:"button"}, listItem);
          if (person.arrived) {
        	  checkbox.checked = true;
          }
          domConstruct.create("a", { id: "anchor"+person.email, href: "ListAttendee.jsp?email="+person.email, innerHTML: person.name + " ("+ person.email+ ") - " +  ((person.arrived) ? "Arrived" : "Not Arrived") }, listItem);
          on(checkbox, "click", function(evt) {updateattendance(checkbox);});
          on(unregisterButton, "click", function(evt) {removeAttendee(unregisterButton);});
        });
	};
	
	register.makerequest = function(searchTerm) {
        request.get("rest/search?filter="+searchTerm.get("value")).then(
      		  function(data){if (data) {processrequest(data);}},
      		  function(err){reportError(err);});
	};
	
	reportError = function(errormessage) {
		var outputField = dom.byId("outputField");
		outputField.innerHTML = "Error: " + errormessage;
	};
	
	return register;
 });